> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/getting-started/event.md).

# Event

To achieve accurate data analysis and successful A/B Testing, you need to systematically collect and manage user behavior data — that is, Events.

This guide provides best practices for designing and managing events optimized for Hackle.

### Event

An Event refers to any action or occurrence triggered by a user within your service. With Hackle, you can collect a wide variety of events and use them as the basis for all data analysis and measuring experiment performance.

**Key Event Examples**

<table><thead><tr><th width="199.52734375">Category</th><th>Examples</th></tr></thead><tbody><tr><td><strong>Behavior-based</strong></td><td>Sign-up completed, search button clicked, product detail page entered, purchase completed, etc.</td></tr><tr><td><strong>System-based</strong></td><td>Server response time, etc.</td></tr></tbody></table>

Based on event data like the above, you can use Hackle in the following ways:

<table><thead><tr><th width="199.9296875">Hackle Service</th><th>Usage Examples</th></tr></thead><tbody><tr><td><strong>A/B Test</strong></td><td>Calculate key metrics such as 'purchase conversion rate'</td></tr><tr><td><strong>Data Analytics</strong></td><td>Analyze user behavior patterns such as event occurrence frequency</td></tr><tr><td><strong>Funnel Analysis</strong></td><td>Identify drop-off points as users progress toward a specific goal (e.g., purchase)</td></tr></tbody></table>

{% hint style="info" %}
To learn how to create and manage events through Hackle, refer to [Event Management](/en/event-management/event-management.md).
{% endhint %}

### Taxonomy

The process of classifying events according to specific rules is called Taxonomy.\
A well-designed Taxonomy allows anyone in the organization to clearly understand and use data, accelerating data-driven decision-making.

To make effective and efficient data-driven decisions, you need to be able to accurately measure and analyze the data you want.

The first step in this process is defining and classifying events — event taxonomy definition — which makes this work critically important.

#### Event Naming Convention

An event naming convention refers to agreed-upon rules within an organization for clearly identifying and classifying events. Establishing a naming convention for events is **critically important** for well-defined and well-organized events.

Build a solid event naming convention to streamline communication across your organization!

**Event Naming Convention Examples**

Through events, we want to record 'where' a specific user performed an action and 'what they did.'

<table><thead><tr><th width="185.46875">Category</th><th width="259.99609375">Description</th><th>Examples</th></tr></thead><tbody><tr><td><strong>name</strong></td><td>The <strong>location</strong> where the action occurred ('where')</td><td><code>home</code>, <code>gnb</code>, <code>login_page</code></td></tr><tr><td><strong>action</strong></td><td>The <strong>action</strong> taken ('what they did')</td><td><code>click</code>, <code>scroll</code>, <code>view</code>, <code>submit</code></td></tr><tr><td><strong>object</strong></td><td>The <strong>element</strong> that was acted upon</td><td><code>search_button</code>, <code>login_form</code>, <code>product_banner</code></td></tr></tbody></table>

Using the categories above, you can construct events as follows:

<table><thead><tr><th width="185.0546875">Taxonomy Category</th><th width="259.80078125">Example</th><th>Description</th></tr></thead><tbody><tr><td><strong>action_name</strong></td><td><code>viewed_home</code></td><td>User <strong>entered (viewed)</strong> the <strong>home</strong> screen</td></tr><tr><td><strong>action_object_name</strong></td><td><code>clicked_search_home</code></td><td>User <strong>clicked (clicked)</strong> the <strong>search button (search)</strong> on the <strong>home</strong> screen</td></tr><tr><td><strong>action_object</strong></td><td><code>clicked_search</code></td><td>User <strong>clicked (clicked)</strong> the <strong>search button (search)</strong> (regardless of location)</td></tr></tbody></table>

For user actions occurring in common areas such as the GNB, you can record them together as `clicked_search_gnb`.\
If you want to separately record the individual page where the GNB is displayed, it is recommended to include the page as a property value in the common event.

{% hint style="info" %}
[Check out the A to Z Guide: From Event Taxonomy Definition to Practical Application 👉](https://hackle.io/ko/post/event-taxonomy/?utm_source=blog)
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/en/getting-started/event.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
